<template>
  <div>
    <div class="dashboard__header">
      <h1 class="dashboard__title">مدیریت بلاگ</h1>
      <div class="dashboard__actions">
        <ResponsiveComponent>
          <Button type="outlined" color='dark' light size="sm" @click.native="$router.push('/dashboard/admin/blog/create')">
            <template #icon>
              <AddIcon />
            </template>
            نوشته جدید
          </Button>
          <template #collapsed>
            <Button type="text" round color='dark' light size="sm" @click.native="$router.push('/dashboard/admin/blog/create')">
              <template #icon>
                <AddIcon />
              </template>
            </Button>
          </template>
        </ResponsiveComponent>
        
        <Button type="text" color='dark' light round size="sm" @click.native="$router.push('/dashboard')">
          <template #icon>
            <BackIcon />
          </template>
        </Button>
      </div>
    </div>
    <div class="dashboard__body">
      <DashboardNavigation class="dashboard__nav" active="blog" />
      <Card title="نوشته ها" class="dashboard__content">
        <template #actions>
          <p class="count">
            {{ count }} عدد
          </p>
        </template>
        <Empty title="نوشته ای برای نمایش وجود ندارد." v-if="posts.length === 0"/>
        <ManagingItemRow v-for="post in posts" :key="post.id" :item="post" baseEditPath="/dashboard/admin/blog" @delete="onDelete" />
      </Card>
    </div>
  </div>
</template>

<script>
import DashboardNavigation from "@/components/layout/DashboardNavigation";
import ManagingItemRow from "@/components/dashboard/ManagingItemRow";
import BackIcon from "@/assets/svgs/back.svg";
import Button from "@/components/base/Button";
import Card from "@/components/base/Card";
import AddIcon from "@/assets/svgs/add.svg";
import Empty from "@/components/dashboard/Empty";
import ResponsiveComponent from "@/components/base/ResponsiveComponent";

export default {
  components: {
    DashboardNavigation,
    ManagingItemRow,
    BackIcon,
    AddIcon,
    Button,
    Card,
    Empty,
    ResponsiveComponent
  },
  head() {
    return {
      title: "مدیریت بلاگ"
    }
  },
  layout: "dashboard",
  async asyncData(context) {
    let posts = [];
    let count = 0;
    await context.store.dispatch('blog/fetchPosts').then(response => {
      posts = response.data.data;
      count = response.data.meta.total;
    }).catch(error => {
      console.log(error);
    });
    return {
      posts,
      count
    }
  },
  methods: {
    onDelete(id) {
      this.$store.dispatch('blog/deletePost', {
        token: this.$store.getters['auth/getToken'],
        id: id
      }).then(response => {
        if (response.status === 200) {
          this.$store.dispatch('notifications/push', {
            message: "نوشته انتخاب شده با موفقیت حذف شد.",
            light: true,
            type: "success",
            timeout: 3000
          });
          this.posts = this.posts.filter(cur => cur.id !== id);
          this.count--;
        }
      }).catch(error => {
        if (error.response.status === 404) {
          this.$store.dispatch('notifications/push', {
            message: "نوشته انتخاب شده برای حذف یافت نشد.",
            type: "error",
            timeout: 3500
          });
        } else {
          this.$store.dispatch('notifications/push', {
            message: "خطا در اتصال به سرور! لطفا دقایقی دیگر دوباره امتحان کنید.",
            type: "error",
            timeout: 3500
          });
        }
      });
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.dashboard__content
  align-self flex-start

.count
  opacity .6
  color $grey 
</style>